from django.db import models

# Create your models here.
from django.utils.translation import gettext_lazy as _

class Vendor(models.Model):
    company=models.ForeignKey('company.Company',related_name='vendor3rd_company',verbose_name='所属企业',on_delete=models.CASCADE,blank=True,null=True)
    name=models.CharField(_('第三方单位名称'),max_length=100,unique=True)    
    code=models.CharField(_('代码'),max_length=10,blank=True,null=True)
    is_active=models.BooleanField(_('是否已上线'),default=True)
    synclogistics=models.BooleanField(_('同步物流数据'),default=False)
    redirect=models.CharField(_('消费者扫码跳转链接'),max_length=200,blank=True,null=True)
    parameter=models.CharField(_('跳转参数名'),max_length=20,blank=True,null=True)
    products=models.JSONField(_('指定产品'),default=list,blank=True,null=True)
    agents=models.JSONField(_('指定经销商'),default=list,blank=True,null=True)    
    remark=models.CharField(_('备注说明'),max_length=100,blank=True,null=True)
    tm=models.DateTimeField(_('时间'),auto_now_add=True)    
    
    class Meta:
        verbose_name = _('第三方信息')
        verbose_name_plural = _('第三方信息')
        #unique_together = ("company","code")

    def __str__(self):
        return self.name


#2022-03-08 一家第三方可能有多个跳转地址
class Redirect(models.Model):
    company=models.ForeignKey('company.Company',verbose_name='企业ID',related_name='redirect_company',on_delete=models.CASCADE)
    vendor=models.ForeignKey(Vendor,verbose_name=_('第三方ID'),related_name='redirect_vendor',blank=True,null=True,on_delete=models.CASCADE)
    code=models.CharField(_('前端跳转代码'),max_length=10,unique=True)
    is_active=models.BooleanField(_('是否已上线'),default=True)
    synclogistics=models.BooleanField(_('同步物流数据'),default=False)
    redirect=models.CharField(_('消费者扫码跳转链接'),max_length=200,blank=True,null=True)
    parameter=models.CharField(_('跳转参数名'),max_length=20,blank=True,null=True)
    products=models.JSONField(_('指定产品'),default=list,blank=True,null=True)
    agents=models.JSONField(_('指定经销商'),default=list,blank=True,null=True)    
    remark=models.CharField(_('备注说明'),max_length=100,blank=True,null=True)
    tm=models.DateTimeField(_('时间'),auto_now_add=True)    

    class Meta:
        verbose_name = _('第三方跳转')
        verbose_name_plural = _('第三方跳转')


class OrderSync(models.Model):
    company=models.ForeignKey('company.Company',verbose_name='企业ID',on_delete=models.CASCADE)
    vendor=models.ForeignKey(Vendor,verbose_name=_('第三方ID'),related_name='ordersync_vendor',blank=True,null=True,on_delete=models.CASCADE)
    through_3rd=models.CharField(_('第三方名称'),max_length=80,db_index=True)  
    dn_number=models.CharField(_('货运单/发货单号'),max_length=50,blank=True,null=True,db_index=True)       
    order_code=models.CharField(_('订单编号'),max_length=50,blank=True,null=True)    
    order_type=models.JSONField(_('订单类型'),default=dict,blank=True,null=True)
    products=models.JSONField(_('产品信息'),default=list,blank=True,null=True) #[{'code':'','name':'','qty':0,'unit':'','remark':''}]    
    customer=models.JSONField(_('客户信息'),default=dict,blank=True,null=True) 
    storehouse=models.JSONField(_('仓库信息'),default=dict,blank=True,null=True)       
    data=models.JSONField(_('接收到的原始数据'),default=dict,blank=True,null=True)
    is_ok=models.BooleanField(_('同步是否成功'),default=True)    
    remark=models.CharField(_('备注说明'),max_length=100,blank=True,null=True)
    dt=models.DateField(_('同步日期'),db_index=True,auto_now_add=True)
    tm=models.DateTimeField(_('同步时间'),auto_now_add=True)    
    tm_modify=models.DateTimeField(_('修改时间'),auto_now_add=True)
    
    class Meta:
        verbose_name = _('同步第三方发货单信息')
        verbose_name_plural = _('同步第三方发货单信息')



class ObjectSync(models.Model):
    company=models.ForeignKey('company.Company',verbose_name='企业ID',on_delete=models.CASCADE)
    through_3rd=models.CharField(_('第三方名称'),max_length=80,db_index=True,blank=True,null=True)  
    ip_address=models.CharField(_('ip地址'),max_length=100)
    app_name=models.CharField(_('app'),max_length=20)
    obj_name=models.CharField(_('obj'),max_length=20)
    src=models.JSONField(_('源数据'),default=dict,blank=True,null=True)
    result=models.JSONField(_('返回值'),default=dict,blank=True,null=True)
    dt=models.DateField(_('日期'),auto_now_add=True,db_index=True)
    tm=models.DateTimeField(_('时间'),auto_now_add=True)

    class Meta:
        verbose_name = _('同步第三方发货单信息')
        verbose_name_plural = _('同步第三方发货单信息')





#2022-02-21 喷码机数据上传BATCH
class InkJetBatch(models.Model):
    company=models.ForeignKey('company.Company',verbose_name=_('企业'),related_name='inkjetbatch_company', on_delete=models.CASCADE)
    user=models.ForeignKey('company.User',verbose_name=_('用户帐号'),on_delete=models.CASCADE)
    salesorder=models.ForeignKey('erp.SalesOrder',verbose_name=_('销售订单'),blank=True,null=True,on_delete=models.CASCADE)
    deliverynote=models.ForeignKey('inventory.DeliveryNote',verbose_name=_('发货单'),blank=True,null=True,on_delete=models.CASCADE)
    dn_number=models.CharField(_('发货单号'),max_length=50,blank=True,null=True)
    ordertype=models.ForeignKey('erp.OrderType',verbose_name=_('订单类型ID'),blank=True,null=True,on_delete=models.CASCADE)    
    store=models.ForeignKey('inventory.Storehouse',verbose_name=_('仓库'),blank=True,null=True,on_delete=models.CASCADE)
    product=models.ForeignKey('product.Product',verbose_name=_('产品'),blank=True,null=True,on_delete=models.CASCADE)    
    qty=models.IntegerField(_('订单数量'),blank=True,null=True)
    unit=models.CharField(_('订单单位'),max_length=20,blank=True,null=True)
    qty0=models.IntegerField(_('订单瓶数'),default=0)   #最小计量单位的数量    
    marking=models.CharField(_('喷码信息'),max_length=100,blank=True,null=True)
    dt = models.DateField(_('日期'), auto_now_add=True, db_index=True)
    tm = models.DateTimeField(_('时间'), auto_now_add=True)
    remark=models.CharField(_('备注说明'),max_length=50,blank=True,null=True)
    #2022-03-23
    outbound=models.BooleanField(_('是否已出库'),default=False)

    class Meta:
        verbose_name = _('喷码机数据上传BATCH')
        verbose_name_plural = _('喷码机数据上传BATCH')



class InkJetDetails(models.Model):
    batch=models.ForeignKey(InkJetBatch,verbose_name=_('喷码BATCH'),on_delete=models.CASCADE)   
    company_id=models.IntegerField(_('企业ID'))     
    salesorder_id=models.IntegerField(_('销售订单ID'),blank=True,null=True,db_index=True)
    deliverynote_id=models.IntegerField(_('发货单ID'),blank=True,null=True,db_index=True)
    product_id=models.IntegerField(_('产品ID'),blank=True,null=True,db_index=True)
    ordertype_id=models.IntegerField(_('订单类型ID'),blank=True,null=True,db_index=True)
    store_id=models.IntegerField(_('仓库ID'),blank=True,null=True,db_index=True)
    label_code=models.CharField(_('标签号码'),max_length=20,db_index=True)
    label_pk_id=models.BigIntegerField(_('主箱标ID'),blank=True,null=True,db_index=True)    
    label_id=models.BigIntegerField(_('标签ID'),blank=True,null=True)
    qty0=models.SmallIntegerField(_('折合瓶数'),blank=True,null=True)   #最小计量单位的数量
    label_pkg=models.SmallIntegerField(_('标签类别'),blank=True,null=True,db_index=True)
    is_ok=models.BooleanField(_('是否正常'),default=True,db_index=True)
    err=models.CharField(_('错误信息'),max_length=100,blank=True,null=True)
    dt = models.DateField(_('日期'), auto_now_add=True,db_index=True)
    tm = models.DateTimeField(_('时间'), auto_now_add=True)
    remark=models.CharField(_('备注说明'),max_length=50,blank=True,null=True)

    class Meta:
        verbose_name = _('喷码机数据上传明细')
        verbose_name_plural = _('喷码机数据上传明细')






# 2023-07-24 不需要推送第三方的客户列表
class Exemption(models.Model):
    company_id=models.IntegerField(_('企业ID'))
    vendor=models.ForeignKey(Vendor,verbose_name=_('第三方'),related_name='exemption_vendor',blank=True,null=True,on_delete=models.CASCADE)
    customer_id=models.IntegerField(_('经销商id'))
    customer_name=models.CharField(_('经销商名称'),max_length=100)
    tm_create=models.DateTimeField(_('创建时间'),blank=True,null=True)
    remark=models.CharField(_('备注说明'),max_length=100,blank=True,null=True)

    class Meta:
        verbose_name = _('不推送第三方的客户列表')
        verbose_name_plural = _('不推送第三方的客户列表')
        unique_together=('company_id','vendor','customer_id')

# 2023-07-24 需推送第三方的batch列表
class BatchPost(models.Model):
    batch=models.ForeignKey('inventory.Batch',verbose_name=_('销售出库BATCH'),on_delete=models.CASCADE)
    company_id=models.IntegerField(_('企业ID'))
    code=models.CharField(_('单据编号'),max_length=30,blank=True,null=True)
    vtype_id=models.SmallIntegerField(_('单据类型'),default=2,blank=True,null=True)
    vendor=models.ForeignKey(Vendor,verbose_name=_('第三方'),related_name='batchpost_vendor',blank=True,null=True,on_delete=models.CASCADE)
    customer=models.JSONField(_('客户信息'),default=dict,blank=True,null=True)
    product=models.JSONField(_('产品信息'),default=dict,blank=True,null=True)
    dt_voucher=models.DateField(_('单据日期'),blank=True,null=True)
    tm_voucher=models.DateTimeField(_('单据时间'),blank=True,null=True)
    tm_create=models.DateTimeField(_('生成时间'),blank=True,null=True,auto_now_add=True)
    tm_post=models.DateTimeField(_('首推时间'),blank=True,null=True)
    success=models.BooleanField(_('推送是否成功'),default=False,blank=True,null=True)
    log=models.JSONField(_('推送日志'),default=list,blank=True,null=True)
    carton_cnt=models.IntegerField(_('箱数'),blank=True,null=True)
    bottle_cnt=models.IntegerField(_('瓶数'),blank=True,null=True)
    remark=models.CharField(_('备注说明'),max_length=100,blank=True,null=True)

    class Meta:
        verbose_name=_('需推送第三方的batch列表')
        verbose_name_plural=_('需推送第三方的batch列表')
        unique_together=('batch','vendor')
    
